libiberty 数字错误漏洞

QQ空间 新浪微博 微信 QQ facebook twitter
漏洞ID 1124129 漏洞类型 缓冲区溢出
发布时间 2017-07-27 更新时间 2017-07-27
CVE编号 CVE-2016-2226 CNNVD-ID CNNVD-201605-140
漏洞平台 Linux CVSS评分 6.8
|漏洞来源
https://www.exploit-db.com/exploits/42386
https://www.securityfocus.com/bid/90103
http://www.cnnvd.org.cn/web/xxk/ldxqById.tag?CNNVD=CNNVD-201605-140
|漏洞详情
libiberty是一个GNU程序使用的子程序的集合。libiberty中的cplus-dem.c文件的‘string_appends’函数存在整数溢出漏洞。远程攻击者可利用该漏洞执行任意代码。
|漏洞EXP
Source: https://gcc.gnu.org/bugzilla/show_bug.cgi?id=69687


The attached program binary causes a buffer overflow in cplus-dem.c when it tries to demangle specially crafted function arguments in the binary. Both the buffer size as well as the buffer content are controlled from the binary.

objdump -x -C <file>
nm -C <file>

Tested on the following configurations
* 2.6.32-573.7.1.el6.x86_64 #1 SMP Tue Sep 22 22:00:00 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux
* 4.1.12-boot2docker #1 SMP Tue Nov 3 06:03:36 UTC 2015 x86_64 x86_64 x86_64 GNU/Linux
* Binutils versions: 2.20 and 2.26


Proof of Concept:
https://github.com/offensive-security/exploit-database-bin-sploits/raw/master/bin-sploits/42386.zip
|受影响的产品
Ubuntu Ubuntu Linux 17.04 Ubuntu Ubuntu Linux 16.04 LTS Ubuntu Ubuntu Linux 14.04 LTS GNU libiberty 0
|参考资料

来源:gcc.gnu.org
链接:https://gcc.gnu.org/bugzilla/show_bug.cgi?id=69687
来源:www.openwall.com
链接:http://www.openwall.com/lists/oss-security/2016/05/05/5